var singleStockTrader =
{
  order_id : 0,
  security : null,
  candle_series : null,
  quantity : 0.0
};

singleStockTrader.init = function(security, quantity, timeframe, max_count)
{
  this.security = security;
  this.quantity = quantity;
  this.candle_series = trader.getCandleSeries(security, timeframe, max_count);
};

singleStockTrader.openOrder = function(operation)
{
  this.order_id = trader.openMarketOrder(this.security, this.quantity, operation);
  if(this.order_id != 0)
  {
    if(operation == OrderOperation.BUY)
      trader.position = TraderPosition.PENDING_LONG;
    else
      trader.position = TraderPosition.PENDING_SHORT;
    return true;
  }
  return false;
};

singleStockTrader.closeOrder = function()
{
  if(trader.closeOrder(this.order_id))
  {
    trader.position = TraderPosition.PENDING_CASH;
    return true;
  }
  return false;
};

singleStockTrader.position = function()
{
  return trader.position;
};

function initOrders(orders)
{
  if(orders.length > 0)
  {
    singleStockTrader.order_id = orders[orders.length-1];
    orderStateChanged(singleStockTrader.order_id);
  }
}

function orderStateChanged(order_id)
{
  if(singleStockTrader.order_id != order_id)
    return;
  var order = trader.getOrder(order_id);
  if(order.state == OrderState.OPENED)
  {
    if(order.operation == OrderOperation.BUY)
      trader.position = TraderPosition.LONG;
    else if(order.operation == OrderOperation.SELL)
      trader.position = TraderPosition.SHORT;
  }
  else if(order.state == OrderState.CLOSED ||
          order.state == OrderState.CANCELLED ||
          order.state == OrderState.FAILED)
  {
    singleStockTrader.order_id = 0;
    trader.position = TraderPosition.CASH;
  }
}

function processTick(tick)
{
  onTick(tick);
  trader.live_indicator = tick.price;
}
